/*
 * @Overview 창고/로케이션 등록
 */

class Tb_warehouse_class {
  constructor(container) {
    this.ajaxUrl = "./warehouse.ajax.php";
    this.tbList = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList() {
    let _this = this;
    let talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);
    const useFlgCheckbox = document.getElementById("USE_FLG").value;
    const whNmInput = document.getElementById("WH_NM").value;
    const whTypeSelect = document.getElementById("WH_TYPE").value;


    ajax_json({
      url: this.ajaxUrl,
      data: {
        mode: "getWarehouseList",
        USE_FLG: useFlgCheckbox,
        WH_NM: whNmInput,
        WH_TYPE: whTypeSelect,
      },
      success: (data) => {
        if(data) {
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
        this.setFilter();
      },
    });

    return true;
  }
  /*
   * @Overview 데이터 필터 함수
   * @Parameter 없음
   * @function 창고, 유형, 사용 여부 필터링
   */
  setFilter() {
  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    this.tbList.addRow({ _STATUS_: "I", USE_FLG:"Y" },true);
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
      this.clearRemove(tgt);
      Tb_location.getMainList(null);
    } else {
      this.tbList.deselectRow();
      tgt.select();
      Tb_location.getMainList(tgt.getData().WH_CD);
    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  }

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    const editor = tgt.getColumn().getDefinition().editor;
    
    switch (tgt.getField()) {
      case "USE_FLG":
      case "IN_FLG":
      case "OT_FLG":
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        tgt.getElement().classList.add("tabulator-editable");
        break;
        // 사업장
      case "BIZ_AREA_NM":
        popBizArea({
          BIZ_AREA_CD: "BIZ_AREA_CD",
          BIZ_AREA_NM: "BIZ_AREA_NM",
        },tgt.getRow());
        break;

        // 거래처
      case "BP_NM":
        popClient({
          BP_CD: "BP_CD",
          BP_NM: "BP_NM",
        },tgt.getRow());
        break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
      default:
        if (!editor) {
          this.rowClick && this.rowClick(e, tgt.getRow());
        }
        break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

 /*
  * @Overview 추가, 수정 및 삭제 데이터 저장
  * @Parameter 없음
  * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
  */
 putData() {

  // 저장 시 상태 변화 없는 row 요청 X
  if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
    this.getMainList();
    return false;
  }


  const blankObj = [];
  const reqData = [];

  this.tbList.getRows().forEach(row => {
    if(row.getData()['_STATUS_']){
      if(Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'USE_FLG').every(key => {

        const value = row._row.data[key];
        return (value === undefined || value === '');
      })){
        blankObj.push(row);
      }else{
        reqData.push(row.getData());
      }
    }
  })


  const postdata = reqData.length == 0 ? false : {
    'mode': 'putWarehouse',
    'reqdata': JSON.stringify(reqData),
  };

  if(!postdata){
    this.getMainList();
    return false;
  };

  if(blankObj.length !== 0){
    kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
      ajax_json({
        url: this.ajaxUrl,
        data: postdata,
        success: (data)=>{
          if (data.code) {
            kuls_success("저장되었습니다.");
            this.getMainList();
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });

    },()=>{
      blankObj.forEach(row=>{
        row.getElement().classList.add("blank-row")
      })
    })
  }else{
    ajax_json({
      url: this.ajaxUrl,
      data: postdata,
      success: (data)=>{
        if (data.code) {
          kuls_success("저장되었습니다.");
          this.getMainList();
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: function (request, status, error) {
        kuls_alert(error.message);
      },
      complete: function () {
      }
    });

  
  }

}

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    let _this = this;
    // field 정의
    const fields = [
      { field:"check", title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter: "rownum", title: "NO", width: 50 },
      { field: "WH_CD", title: "창고 코드", width: 150,
        editor: tb_custom_editor.pkCode,
        editorParams: {type: 'upper'}, 
        formatter: tb_custom_formatter.pkCode,
        formatterParams : {tableClass: this},
      },
      { field: "WH_NM", title: "창고명", width: 150,  editor:"input", cssClass:"editable-cell", hozAlign:"left",},
      { field: "IN_FLG",      title: "입하창고", width: 100, cssClass: "tabulator-editable", formatter: tb_common_funtions.formatterToggleboxIcon, formatterParams: {checkval:'Y'}},
      { field: "OT_FLG",      title: "출하창고", width: 100, cssClass: "tabulator-editable", formatter: tb_common_funtions.formatterToggleboxIcon, formatterParams: {checkval:'Y'}},
      { field: "WH_TYPE", title: "창고 유형", width: 200, cssClass:"user-list", editor:"list", editorParams: {values: varsWH_TYPE,}, formatter: tb_common_funtions.formatterSelect, formatterParams: {values: varsWH_TYPE,}},
      { field: "BIZ_AREA_NM", title: "사업장", width: 200, hozAlign:"left", editor:tb_custom_editor.pop},
      { field: "BIZ_AREA_CD", title: "사업장코드", visible: false },
      { field: "BP_NM", title: "거래처", width: 150, hozAlign:"left", editor:tb_custom_editor.pop },
      { field: "BP_CD", title: "거래처코드", visible: false},
      { field: "REMK", title: "비고", width: 300, editor:"input",hozAlign:"left" },
      { field: "USE_FLG", title: "사용", width: 50, cssClass: "tabulator-editable", formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: {checkval:'Y'} },
    ];
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    _this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode: "highlight"
    });

    /*
     * @Overview 테이블 만들어지면 데이터 불러오기
     * @Parameter 없음
     */
    this.tbList.on("tableBuilt", () => {
      this.getMainList();
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e,tgt) => {
      this.cellClick && this.cellClick(e,tgt);
    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
    // 조회
    ["click", "keypress"].forEach((evt) => {
      const filterBtn = document.querySelector("#filter_btn");
      filterBtn.addEventListener(evt, () => {
        this.getMainList && this.getMainList();
        Tb_location.getMainList && Tb_location.getMainList();

      });
    });
    // 저장
    ["click", "keypress"].forEach((evt) => {
      const putBtn = document.querySelector("#put_btn");
      putBtn.addEventListener(evt, () => {
        this.putData && this.putData();
        Tb_location.putData();
      });
    });
  }
}

class Tb_location_class {
  constructor(container) {
    this.ajaxUrl = "./warehouse.ajax.php";
    this.tbList = "";
    this.code = "";

    this.container = document.querySelector(container);
    this.table = this.container.querySelector(".hy-table")
    this.upBtn = this.container.querySelector(".up-btn") || ""
    this.downBtn = this.container.querySelector(".down-btn") || ""
    this.addBtn = this.container.querySelector(".add-btn")
    this.removeBtn = this.container.querySelector(".remove-btn")
  }

  /*
   * @Overview 데이터 세팅 함수
   * @Parameter 없음
   */
  getMainList(code) {
    this.code = code;
    let talert = window.setTimeout(()=> { this.tbList.alert("Loading ...") }, 1000);

    ajax_json({
      url: this.ajaxUrl,
      data: { mode: "getLocation", WH_CD: this.code },
      success: (data) => {
        if(data.code) {
          this.tbList.setData(data.data);
        }else{
          kuls_alert(data.mesg);
        }
      },
      error: (req, status, err) => {
        kuls_alert(err.message);
      },
      complete: () => {
        window.clearTimeout(talert);
        this.tbList.clearAlert();
      },
    });
    return true;
  }

  /*
   * @Overview 테이블 행 추가 함수
   * @Parameter 없음
   * @function 기본키, _STATUS_:I 값을 넣은 행 추가
   */
  addRow() {
    if(this.code){
      this.tbList.addRow({ _STATUS_: "I", WH_CD: this.code, USE_FLG:"Y" },true);
    }else{
      kuls_alert("창고를 선택해주세요")
    }
  }

  /*
   * @Overview 테이블 행 삭제 함수
   * @Parameter 없음
   * @function 선택된 모든 행 STATUS D
   */
  removeRow() {
    const selectedRows = this.tbList.getRows().filter(row=>{
      return row.getData().check ==="Y"
    });

    if(selectedRows.length > 0 ){

        // 선택된 각 행 삭제
        selectedRows.forEach((row) => {
          // STAUS D로 바꾸기
          row.getData()._STATUS_ = row.getData()._STATUS_=="I"?null:"D";
    
          const rowElement = row.getElement();
          rowElement.classList.add("remove-row");
    
        });
    }else{
      kuls_alert("삭제할 행을 선택해주세요.")
    }
  }

  /*
   * @Overview 테이블 행 선택 함수
   * @Parameter 없음
   * @function 선택된 모든 행 색 변경
   */
  rowClick(e, tgt) {
    if (tgt.isSelected()) {
      tgt.deselect();
      this.clearRemove(tgt);
    } else {
      tgt.select();
    }
  }

  /*
   * @Overview 삭제 취소 함수
   * @Parameter 삭제 행
   * @function  클릭시 삭제 취소 & STATUS를 공란으로 변경
   */
  clearRemove(tgt){
    if(tgt._row.data._STATUS_ == "D"){
      tgt._row.data._STATUS_ = "";
      tgt._row.getElement().classList.remove("remove-row")
    }
  } 

  /*
   * @Overview cell 클릭 함수
   * @Parameter 클릭한 cell
   * @Function 클릭한 cell의 filed 값에 따라 토글 상태 변경 또는 팝업
   */
  cellClick(e, tgt) {
    var editor = tgt.getColumn().getDefinition().editable;
    
    switch (tgt.getField()) {
      case "USE_FLG":
        tgt.getRow().deselect();
        tgt.setValue(tgt.getValue() == "Y" ? "N" : "Y");
        break;
      case "check":
        tgt.setValue(tgt.getValue() == "Y" ? "" : "Y");
        this.clearRemove(tgt.getRow())
      break;
    }
  }

  /*
   * @Overview 테이블 셀 수정 함수
   * @Parameter 셀
   * @function 셀 편집이 이후 저장될수 있도록 _STATUS_:U로 데이터 업데이트
   */
  cellEdited(cell) {
    cell.getData()._STATUS_ = cell.getData()._STATUS_ || "U";
  }

  /*
   * @Overview 추가, 수정 및 삭제 데이터 저장
   * @Parameter 없음
   * @Function 기본키 중복 확인
   * @Function _STATUS_ U, I, D인 데이터베이스 가져와서 처리.
   */
// putData() {
// }


 /*
  * @Overview 추가, 수정 및 삭제 데이터 저장
  * @Parameter 없음
  * @Function _STATUS_ : U, I, D Row 인 것 php 처리.
  */
  putData() {
    // let _this = this;

    // 저장 시 상태 변화 없는 row 요청 X
    if(this.tbList.getData().filter(row=> row._STATUS_).length == 0){
      this.getMainList();
      return false;
    }


    const blankObj = [];
    const reqData = [];

    this.tbList.getRows().forEach(row => {
      if(row.getData()['_STATUS_']){
        if(Object.keys(row._row.data).filter(key => key !== '_STATUS_' && key !== 'USE_FLG'  && key !== 'WH_CD').every(key => {

          const value = row._row.data[key];
          return (value === undefined || value === '');
        })){
          blankObj.push(row);
        }else{
          reqData.push(row.getData());
        }
      }
    })


    const postdata = reqData.length == 0 ? false : {
      'mode': 'putLocation',
      'reqdata': JSON.stringify(reqData),
      'WH_CD' : this.code
    };

    if(!postdata){
      this.getMainList(this.code);
      return false;
    };

    if(blankObj.length !== 0){
      kuls_confirm("비어있는 행을 무시하고 진행하시겠습니까?","",()=>{
        ajax_json({
          url: this.ajaxUrl,
          data: postdata,
          success: (data)=>{
            if (data.code) {
              kuls_success("저장되었습니다.");
              this.getMainList(this.code);
            }else{
              kuls_alert(data.mesg);
            }
          },
          error: function (request, status, error) {
            kuls_alert(error.message);
          },
          complete: function () {
          }
        });

      },()=>{
        blankObj.forEach(row=>{
          row.getElement().classList.add("blank-row")
        })
      })
    }else{
      ajax_json({
        url: this.ajaxUrl,
        data: postdata,
        success: (data)=>{
          if (data.code) {
            kuls_success("저장되었습니다.");
            this.getMainList();
          }else{
            kuls_alert(data.mesg);
          }
        },
        error: function (request, status, error) {
          kuls_alert(error.message);
        },
        complete: function () {
        }
      });

    
    }

  }

  /*
   * @Overview 최초 실행 함수
   * @Parameter 없음
   */
  init() {
    // field 정의
    const fields = [
      { field:"check", title: "삭제", width: 50, headerSort: false,
        formatter: tb_common_funtions.formatterCheckboxIcon,
        formatterParams: { checkval: "Y" },
      },
      { formatter: "rownum",    title: "NO", width: 50, },
      { field: "LOC_CD",        title: "로케이션 코드", width: 150,
        editor: tb_custom_editor.pkCode,
        editorParams: {type: 'upper'}, 
        formatter: tb_custom_formatter.pkCode,
        formatterParams : {tableClass: this},
        // validator: "alphanumeric",
      },
      { field: "LOCATION_NM",   title: "로케이션명",    width: 150,   cssClass:"editable-cell", editor: tb_custom_editor.upper, },
      { field: "LOCATION_TYPE", title: "로케이션유형",  width: 150,   cssClass:"user-list tabulator-editable",
        editor:"list", 
        editorParams: {values: varsLOCATION_TYPE,}, 
        formatter: tb_common_funtions.formatterSelect, 
        formatterParams: {values: varsLOCATION_TYPE,}
      },
      { field: "LOAD_TYPE",     title: "적재방법",      width: 150,   cssClass:"user-list tabulator-editable",   editor:"list", editorParams: {values: varsLOAD_TYPE,}, formatter: tb_common_funtions.formatterSelect, formatterParams: {values: varsLOAD_TYPE,}, },
      { field: "REMK",          title: "비고",          width: 300,   editor:"input" },
      { field: "USE_FLG",       title: "사용",          width: 50,    cssClass:"tabulator-editable",    formatter: tb_common_funtions.formatterToggleboxGreenIcon, formatterParams: {checkval:'Y'} },
    ];
    const commonFieldData = {
      headerSort: true,
      vertAlign: "middle",
      hozAlign: "center",
      resizable: "header", //Resize 는 헤더에서만 가능
      headerHozAlign: "center", //헤더 정렬
      headerSortTristate: true, //데이터 정렬 => 정/역/초기화
    };

    /*
     * @Overview tabulator 객체 생성
     * @Parameter 생성 위치(html class값)
     */
    this.tbList = new Tabulator(this.table, {
      layout: "fitColumns",
      data: [], //기본 데이터
      columns: fields, //컬럼 설정
      columnDefaults: commonFieldData,
      headerSortElement: "<i class='bi'></i>", //정렬 아이콘
      validationMode: "highlight"
    });

    /*
     * @Overview 유효성 검사메세지 띄우기
     * @Parameter cell, 입력값, validators
     */
    this.tbList.on("validationFailed", (cell, value, validators)=>{
      cell.setValue("");
      let errMsg = ""
      switch(validators[0].type){
        case "alphanumeric":
          errMsg = " 필드는 한글과 특수문자를 입력할 수 없습니다.";
          break;
        case "numeric":
          errMsg = " 필드는 숫자만 입력할 수 있습니다.";
          break;
        default:
          errMsg = " 필드는 "+ validators[0].parameters;
          break;
          
      };
      
      kuls_warning(cell.getColumn().getDefinition().title + errMsg );
    });

    /*
     * @Overview cell 클릭시 체크 또는 팝업
     * @Parameter 이벤트, 셀
     */
    this.tbList.on("cellClick", (e,tgt) => {
      this.cellClick && this.cellClick(e,tgt);

    });
    
    /*
     * @Overview cell 수정 함수
     * @Parameter cell
     * @Function status u로 바꿀것
     */
    this.tbList.on("cellEdited", (cell) => {
      this.cellEdited && this.cellEdited(cell);
    });

    // 추가
    ["click", "keypress"].forEach((evt) => {
      this.addBtn.addEventListener(evt, () => {
        this.addRow && this.addRow();
      });
    });
    // 삭제
    ["click", "keypress"].forEach((evt) => {
      this.removeBtn.addEventListener(evt, () => {
        // 삭제 함수
        this.removeRow && this.removeRow();
      });
    });
  }
}





const Tb_warehouse = new Tb_warehouse_class("#main_table");
Tb_warehouse.init();
const Tb_location = new Tb_location_class("#sub_table");
Tb_location.init();
